Tp::BaseProtocolAddressingInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::BaseProtocolAddressingInterface Class Reference
Connection manager service implementation

Base class for implementations of Protocol.Interface.Addressing. More...

`#include <TelepathyQt/BaseProtocolAddressingInterface>`

Inherits Tp::AbstractProtocolInterface.

## Public Types
typedef Callback3< QString, const QString &, const QString &, DBusError * > | NormalizeVCardAddressCallback
typedef Callback2< QString, const QString &, DBusError * > | NormalizeContactUriCallback

## Public Member Functions
virtual | ~BaseProtocolAddressingInterface ()
QVariantMap | immutableProperties () const
QStringList | addressableVCardFields () const
void | setAddressableVCardFields (const QStringList &vcardFields)
QStringList | addressableUriSchemes () const
void | setAddressableUriSchemes (const QStringList &uriSchemes)
void | setNormalizeVCardAddressCallback (const NormalizeVCardAddressCallback &cb)
QString | normalizeVCardAddress (const QString &vcardField, const QString &vcardAddress, DBusError *error)
void | setNormalizeContactUriCallback (const NormalizeContactUriCallback &cb)
QString | normalizeContactUri (const QString &uri, DBusError *error)
Public Member Functions inherited from Tp::AbstractProtocolInterface
| AbstractProtocolInterface (const QString &interfaceName)
virtual | ~AbstractProtocolInterface ()
Public Member Functions inherited from Tp::AbstractDBusServiceInterface
| AbstractDBusServiceInterface (const QString &interfaceName)
virtual | ~AbstractDBusServiceInterface ()
QString | interfaceName () const
DBusObject * | dbusObject () const
bool | isRegistered () const
bool | notifyPropertyChanged (const QString &propertyName, const QVariant &propertyValue)
Public Member Functions inherited from Tp::Object
virtual | ~Object ()
Public Member Functions inherited from Tp::RefCounted
| RefCounted ()
virtual | ~RefCounted ()

## Static Public Member Functions
static BaseProtocolAddressingInterfacePtr | create ()
template<typename BaseProtocolAddressingInterfaceSubclass >
static SharedPtr < BaseProtocolAddressingInterfaceSubclass > | create ()

## Protected Member Functions
| BaseProtocolAddressingInterface ()
Protected Member Functions inherited from Tp::AbstractDBusServiceInterface
virtual bool | registerInterface (DBusObject *dbusObject)
Protected Member Functions inherited from Tp::Object
| Object ()
void | notify (const char *propertyName)

## Additional Inherited Members
Signals inherited from Tp::Object
void | propertyChanged (const QString &propertyName)

## Detailed Description

Base class for implementations of Protocol.Interface.Addressing.

## Member Typedef Documentation

typedef Callback3<QString, const QString &, const QString &, DBusError*> Tp::BaseProtocolAddressingInterface::NormalizeVCardAddressCallback

typedef Callback2<QString, const QString &, DBusError*> Tp::BaseProtocolAddressingInterface::NormalizeContactUriCallback

## Constructor & Destructor Documentation

Tp::BaseProtocolAddressingInterface::~BaseProtocolAddressingInterface | ( |  | ) |
| virtual

Class destructor.

Tp::BaseProtocolAddressingInterface::BaseProtocolAddressingInterface | ( |  | ) |
| protected

Class constructor.

## Member Function Documentation

static BaseProtocolAddressingInterfacePtr Tp::BaseProtocolAddressingInterface::create | ( |  | ) |
| inlinestatic

template<typename BaseProtocolAddressingInterfaceSubclass >

static SharedPtr<BaseProtocolAddressingInterfaceSubclass> Tp::BaseProtocolAddressingInterface::create | ( |  | ) |
| inlinestatic

QVariantMap Tp::BaseProtocolAddressingInterface::immutableProperties | ( |  | ) | const
| virtual

Return the immutable properties of this interface.

Immutable properties cannot change after the interface has been registered on a service on the bus with registerInterface().

Returns
  The immutable properties of this interface.

Implements Tp::AbstractDBusServiceInterface.

QStringList Tp::BaseProtocolAddressingInterface::addressableVCardFields | ( |  | ) | const

Return the list of addressable vcard fields that have been set with setAddressableVCardFields().

This list is exposed as the AddressableVCardFields property of this interface on the bus and represents the vcard fields that can be used to request a contact for this protocol, normalized to lower case.

Returns
  The list of addressable vcard fields that have been set with setAddressableVCardFields().

See Also
  setAddressableVCardFields()

void Tp::BaseProtocolAddressingInterface::setAddressableVCardFields | ( | const QStringList & | vcardFields | ) |

Set the list of vcard fields that can be used to request a contact for this protocol.

All the field names should be normalized to lower case.

Parameters

  vcardFields | The list of vcard fields to set.

See Also
  addressableVCardFields()

QStringList Tp::BaseProtocolAddressingInterface::addressableUriSchemes | ( |  | ) | const

Return the list of URI schemes that have been set with setAddressableUriSchemes().

This list is exposed as the AddressableURISchemes property of this interface on the bus and represents the URI schemes that are supported by this protocol, like "tel" or "sip".

Returns
  The list of addressable URI schemes that have been set with setAddressableUriSchemes().

See Also
  setAddressableUriSchemes()

void Tp::BaseProtocolAddressingInterface::setAddressableUriSchemes | ( | const QStringList & | uriSchemes | ) |

Set the list of URI schemes that are supported by this protocol.

Parameters

  uriSchemes | The list of URI schemes to set.

See Also
  addressableUriSchemes()

void Tp::BaseProtocolAddressingInterface::setNormalizeVCardAddressCallback | ( | const NormalizeVCardAddressCallback & | cb | ) |

Set a callback that will be called from a client to normalize a given vcard address.

This callback will be called when the NormalizeVCardAddress method on the Protocol.Interface.Addressing D-Bus interface has been called.

Parameters

  cb | The callback to set.

See Also
  normalizeVCardAddress()

QString Tp::BaseProtocolAddressingInterface::normalizeVCardAddress | ( | const QString & | vcardField,
|  | const QString & | vcardAddress,
|  | DBusError * | error
| ) |  |

Return a normalized version of the given vcardAddress, which corresponds to the given vcardField, by calling the callback that has been set with setNormalizeVCardAddressCallback().

Parameters

  vcardField | The vcard field of the address we are normalizing.
  vcardAddress | The address to normalize, which is assumed to belong to a contact.
  error | A pointer to a DBusError instance where any possible error will be stored.

Returns
  A normalized version of the given vcardAddress, or an empty string if no callback to do the normalization has been set with setNormalizeVCardAddressCallback().

See Also
  setNormalizeVCardAddressCallback()

void Tp::BaseProtocolAddressingInterface::setNormalizeContactUriCallback | ( | const NormalizeContactUriCallback & | cb | ) |

Set a callback that will be called from a client to normalize a given contact URI.

This callback will be called when the NormalizeContactURI method on the Protocol.Interface.Addressing D-Bus interface has been called.

Parameters

  cb | The callback to set.

See Also
  normalizeContactUri()

QString Tp::BaseProtocolAddressingInterface::normalizeContactUri | ( | const QString & | uri,
|  | DBusError * | error
| ) |  |

Return a normalized version of the given contact URI, uri, by calling the callback that has been set with setNormalizeContactUriCallback().

Parameters

  uri | The contact URI to normalize.
  error | A pointer to a DBusError instance where any possible error will be stored.

Returns
  A normalized version of the given uri, or an empty string if no callback to do the normalization has been set with setNormalizeContactUriCallback().

See Also
  setNormalizeContactUriCallback()